#!/usr/bin/python

import simplejson as json
from arsenal_lib import *

if len(sys.argv) < 2:
    sys.stderr.write("Usage: " + sys.argv[0] + " <tag> <source-package>")
    exit(1)

total_count = 0
tag         = sys.argv[1]
source_pkgs = sys.argv[2:]
arsenal     = Arsenal()
d           = arsenal.load_project("ubuntu")

for source_pkg in source_pkgs:
    for bugtask in d.searchTasks(search_text=source_pkg, tags=tag):
        if bugtask.bug_target_display_name != source_pkg + " (Ubuntu)":
            continue

        bug = ArsenalBug(bugtask.bug, arsenal.launchpad)
        bug.source_pkg = source_pkg

        print json.dumps({
                'id'         : bug.id,
                'title'      : bug.title,
                'package'    : source_pkg,
                'tags'       : bug.tags,
                'status'     : bugtask.status,
                'importance' : bugtask.importance
                })

