#!/usr/bin/python

from arsenal_lib import *

if len(sys.argv) < 2:
    sys.stderr.write("Usage: " + sys.argv[0] + " <tag> <source-package>")
    exit(1)

total_count = 0
tag         = sys.argv[1]
source_pkgs = sys.argv[2:]
arsenal     = Arsenal()
d           = arsenal.load_project("ubuntu")

print "== Bugs tagged '" + tag + "' =="
for source_pkg in source_pkgs:
    count = 0
    print "=== " + source_pkg + " ==="
    for bugtask in d.searchTasks(search_text=source_pkg, tags=tag):
        if bugtask.bug_target_display_name != source_pkg + " (Ubuntu)":
            continue

        bug = ArsenalBug(bugtask.bug, arsenal.launchpad)
        print bug.id, " " + bugtask.status + " " + bug.title
        count += 1
        total_count += 1

print total_count, " total bugs tagged '" + tag + "'"
