#!/usr/bin/python

import simplejson as json
import time
from arsenal_lib import *

if len(sys.argv) < 2:
    sys.stderr.write("Usage: " + sys.argv[0] + " <source-package>\n")
    exit(1)

pkgs        = sys.argv[1:]
sep         = "["

for pkg_name in pkgs:
    count_status = {}
    count_importance = {}
    #count_upstream = {}
    #count_age = {}
    #count_last_touched = {}
    #count_affected = {'1':0, '10':0, '100':0, '1000':0}
 
    numtries = 5
    while numtries>0:
        numtries -= 1
        try:
            arsenal     = Arsenal()
            d           = arsenal.load_project("ubuntu")

            pkg         = d.getSourcePackage(name = pkg_name)
            for bugtask in pkg.searchTasks():
                # Count status
                if not bugtask.status in count_status:
                    count_status[bugtask.status] = 0
                count_status[bugtask.status] += 1

                # Count importance
                if not bugtask.importance in count_importance:
                    count_importance[bugtask.importance] = 0
                count_importance[bugtask.importance] += 1
                exit
                
        except:
            # Keep trying...
            time.sleep(30)

    # Skip printing out packages with no data
    if len(count_status) == 0 and len(count_importance) == 0:
        continue
    
    print sep
    sep = ","
    print json.dumps({
        pkg_name: {
            'status':          count_status,
            'importance':      count_importance
            }
        }),

# TODO:  This doesn't work (LP: #322135)
#
#        # Count upstream watch
#        for peertask in bugtask.related_tasks:
#            if peertask.bug_target_display_name.endswith("(Ubuntu)"):
#                continue
#        
#            try:
#                if not peertask.bug_watch == None:
#                    if not bugtask.status in count_upstream:
#                        count_upstream[bugtask.status] = 0
#                        count_upstream[bugtask.status] += 1
#            except:
#                continue

print "\n]"
