#!/usr/bin/python

# Purpose of script is to close all bugs in a given package with
# friendly comment about the change.

from arsenal_lib import *

if len(sys.argv) < 2:
    sys.stderr.write "Usage: " + sys.argv[0] + " <source-package>"
    exit(1)

source_pkgs = sys.argv[1:]
arsenal     = Arsenal()
d           = arsenal.load_project("ubuntu")

message = """
This package has become obsolete so we're closing out the bug report as WONTFIX.
Thanks for reporting it though!
"""

for pkg in source_pkgs:
    subject = pkg + " is obsolete"

    for bugtask in d.searchTasks(search_text=pkg):
        if bugtask.bug_target_display_name != pkg + " (Ubuntu)":
            continue

        bug = ArsenalBug(bugtask.bug, arsenal.launchpad)

        print "Set from " + bugtask.status + " to Won't Fix: " + bug.title
        print bug.append_comment(text)
        bugtask.transitionToStatus(status = "Won't Fix")
