#!/usr/bin/python

import sys
from template import Template
from template.util import TemplateException, Literal

if len(sys.argv) < 2:
    sys.stderr.write "Usage: " + sys.argv[0] + " <tag> <source-package>"
    exit(1)

TEMPLATE_MAIN    = "templates/index.tt2"
TEMPLATE_CONTENT = "templates/table.tt2"
# TODO:  Can the pkg-page tt2 fit into the table.tt2 template?

tag    = "historical-packages"
tt2    = Template()

# TODO:
# * Come up with file hierarchy for json files
# * Create 10 sample json files to work with
# * Code to load up the json files into the debs data structure
# * What other data members should be in the json file format?
# * Should the data structure be renamed?
# * Add mechanism for handling changes in the debian/ dir version
# * Add mechanism for tracking pre-requisites
# * Can this be generalized further to be less xorg-specific?
# * Create an external json file with the rels data structure

debs   = load_json("debs.json") # TODO: Load directory-full of json files
# Data structure contents:
#    indent
#    commit
#    commit_date
#    commit_short
#    release
#    style   => 'git'

# TODO:  Analyze and re-think this logic...
for d in debs:
    if d.release:
        if d.release == 'master':
            d.name = 'Xorg-git (master)'
            d.version = d.commit_short
        else:
            d.style = 'xorg'
            d.version = d.release
            # TODO:  Detect Pre-releases (have .9* in version)
            d.name = 'Xorg (Release)'

            # Prepend Ubuntu/Debian packages
            if rels.has(d.release):
                rows.push(rels.{d.release})  # TODO Syntax?
    else:
        # TODO:  Set up version string according to debian rules
        d.version = d.commit_short

    rows.push(d)

# Look for packages in debs and attach
for row in rows:
    version = row.version
    if debs.has(version):
        for dist in debs.{d.version}.keys: # TODO Syntax?
            for archi in debs.{d.version}.{dist}.keys:
                row.debs.{dist}.{arch} = debs.version.dist.arch


# TODO:  Extract debian sorting algorithms from versions_current script

try:
    content = tt2.process(TEMPLATE_CONTENT, {
            'rows': rows,
            'dists': ('hardy', 'intrepid', 'jaunty')
            } )
    print tt2.process(TEMPLATE_MAIN, {
            'title': 'Historical Package Page',
            'content': content
            } )


except TemplateException, e:
    print >>sys.stderr, "ERROR: %s" % e

